/* unixxdos 1.0, by André Gillibert, Copyright 2010
 * This program is licensed under the terms of the WTFPL 
 * See ./LICENSE 
 * */
#include <unistd.h>

static char ibuffer[2048], obuffer[2*sizeof(ibuffer)];
size_t occupied;
static void translate_and_output_buffer(void) {
	char *end, *sip, *ip = ibuffer, *op = obuffer;
	
	end = ibuffer + occupied;
	while((end - ip) > 2
	    || (ip < end && !(end[-1] == '\r' && ip[0] == '\r') )
	    ) {
		if (ip[0] == '\r' && ip[1] == '\r' && ip[2] == '\n') {
			op[0] = ip[0];
			op[1] = ip[1];
			op[2] = ip[2];
			op+=3; ip+=3;
		} else if (ip[0] == '\r' && ip[1] == '\n') {
			*op++ = '\n';
			ip+=2;
		} else if (ip[0] == '\n') {
			op[0] = '\r';
			op[1] = '\n';
			op+=2;
			ip++;
		} else *op++ = *ip++;
	}
	write(STDOUT_FILENO, obuffer, op - obuffer);
	sip = ibuffer;
	if (ip == end-2) *sip++ = *ip++;
	if (ip == end-1) *sip++ = *ip++;
	occupied = sip - ibuffer;
}
int main(void) {
	ssize_t sz;
	while((sz=read(0, ibuffer+occupied, sizeof(ibuffer)-occupied))>0) {
		occupied += sz;
		translate_and_output_buffer();
	}
	write(STDOUT_FILENO, ibuffer, occupied);
	if (sz == -1) return 1;
	return 0;
}
